<%@include file="include/header.jsp"%>
<%!
//-----------------------------------------------
boolean hasBlacklist(int blacklistType){
	if(blacklistType != 8 && blacklistType != 99){
		return true;
	}
	return false;
}

//-----------------------------------------------
void update(CategorySystemDao dao){
	if(demoFlag){
		errList.add("Not allowed on demo site.");
		return;
	}

	// License update.
	String licenseKey = paramString("licenseKey");
	if(isNotEmpty(licenseKey)){
		LicenseDao licDao = new LicenseDao();

		if(!licDao.isValidLicenseKey(licenseKey)){
			errList.add("Invalid license key.");
			return;
		}
		
		if(licDao.isExpiredLicenseKey(licenseKey)){
			errList.add("Expired license key.");
			return;
		}

		if(new LicenseDao().updateLicenseKey(licenseKey)){
			succList.add("Data updated.");
			warnList.add("Restarting is required to apply the change.");
		}
		else{
			errList.add("Invalid license key.");
		}
		return;
	}

	// Change blacklist type.
	int blacklistType = paramInt("blacklistType");
	if(blacklistType == 4 && !dao.hasKomodiaLicense()){
		errList.add("Cloudlist license required.");
		return;
	}

	if(dao.updateBlacklistType(blacklistType)){
		succList.add("Data updated.");
		warnList.add("Restarting is required to apply the change.");
	}
}

//-----------------------------------------------
void updatePolicyGloblist(PolicyGloblistDao dao){
	PolicyGloblistData data = dao.selectOne();

	data.blockAds = paramBoolean("blockAds");
	data.blockPhimal = paramBoolean("blockPhimal");
	data.blockPorn = paramBoolean("blockPorn");
	data.adRemove = paramBoolean("adRemove");

	// Update it.
	if(dao.update(data)){
		succList.add("Data updated.");
	}
}
%>
<%
//-----------------------------------------------
// Set permission for this page.
permission.addAdmin();

//Check permission.
if(!checkPermission()){
	return;
}

// Create data access object.
CategorySystemDao dao = new CategorySystemDao();
PolicyGloblistDao pgDao = new PolicyGloblistDao();

// Action.
String actionFlag = paramString("actionFlag");
if(actionFlag.equals("update")){
	update(dao);
}
if(actionFlag.equals("updatePolicyGloblist")){
	updatePolicyGloblist(pgDao);
}

// 4 = Cloudlist, 5 = Jahaslist, 8 = Globlist, 99 = None.
int gBlacklistType = dao.getBlacklistType();
String gLicenseEndDate = dao.getLicenseEndDate();
int gLicenseMaxUser = dao.getLicenseMaxUser();
%>
<!-- Action info -->
<%@include file="include/ab-notify.jsp"%>
<!-- /Action info -->

<!-- Breadcrumb -->
<div class="container-fluid primary" style="margin-top:-5px;">
	<ol class="breadcrumb" style="margin-left:10px; margin-right:10px;">
		<li class="breadcrumb-item">CATEGORY</li>
		<li class="breadcrumb-item text-info">SYSTEM</li>
	</ol>
</div>
<!-- /Breadcrumb -->

<!-- Form -->
<div class="container-fluid">
	<div class="card bg-light m-2 expand-lg">
		<div class="card-body">
			<form action="<%= getPageName()%>" method="post">
				<input type="hidden" name="actionFlag" value="update">
				<div class="form-group col-lg-8">
					<label class="col-form-label">Categorization Type</label>
					<select class="form-control" id="blacklistType" name="blacklistType">
						<option value="5" <%if(gBlacklistType == 5){out.print("selected");}%>>Jahaslist - Local database and dynamic classification by NxClassifier.</option>
						<option value="4" <%if(gBlacklistType == 4){out.print("selected");}%>>Cloudlist - Cloud based domain categorization service.</option>
						<option value="8" <%if(gBlacklistType == 8){out.print("selected");}%>>Globlist - Free domain categorization database with global policy.</option>
					</select>

<%if(hasBlacklist(gBlacklistType)){%>
					<small id="input-help" class="form-text text-muted">
						License info : End date = <%= gLicenseEndDate%> / Max user = <%= gLicenseMaxUser%>
					</small>
<%}%>

				</div>
				<div class="form-group col-lg-8">
					<button type="submit" class="btn btn-primary">Submit</button>
				</div>
			</form>
		</div>
	</div>
</div>
<!-- /Form -->

<!-- Globlist Policy -->
<%
if(gBlacklistType == 8){
	PolicyGloblistData pgData = pgDao.selectOne();
	//int pgCount = pgDao.selectCount();
%>
<!-- Form -->
<p>
<div class="container-fluid">
	<div class="card bg-light m-2 expand-lg">
		<div class="card-body">
			<form action="<%= getPageName()%>" method="post">
				<input type="hidden" name="actionFlag" value="updatePolicyGloblist">
				<div class="form-group col-lg-8 text-secondary">
					Globlist is a free domain categorization database derived from Jahaslist. It works on global policy level. At the moment, Globlist has more than<br>
					670,000 domains classified into 3 categories. It updates itself automatically in background.
				</div>
				<div class="form-group col-lg-8">
					<div class="custom-control custom-checkbox">
						<input type="checkbox" class="custom-control-input" id="blockAds"
							name="blockAds" <%if(pgData.blockAds){out.print("checked");}%>>
						<label class="custom-control-label" for="blockAds">Block Ads</label>
					</div>
				</div>
				<div class="form-group col-lg-8">
					<div class="custom-control custom-checkbox">
						<input type="checkbox" class="custom-control-input" id="blockPhimal"
							name="blockPhimal" <%if(pgData.blockPhimal){out.print("checked");}%>>
						<label class="custom-control-label" for="blockPhimal">Block Phishing/Malware</label>
					</div>
				</div>
				<div class="form-group col-lg-8">
					<div class="custom-control custom-checkbox">
						<input type="checkbox" class="custom-control-input" id="blockPorn"
							name="blockPorn" <%if(pgData.blockPorn){out.print("checked");}%>>
						<label class="custom-control-label" for="blockPorn">Block Porn</label>
					</div>
				</div>
				<div class="form-group col-lg-8">
					<div class="custom-control custom-checkbox">
						<input type="checkbox" class="custom-control-input" id="adRemove"
							name="adRemove" <%if(pgData.adRemove){out.print("checked");}%>>
						<label class="custom-control-label" for="adRemove">Ad-remove</label>
					</div>
				</div>
				<div class="form-group col-lg-8">
					<button type="submit" class="btn btn-primary">Submit</button>
				</div>
			</form>
		</div>
	</div>
</div>
<!-- /Form -->
<%}%>

<%if(hasBlacklist(gBlacklistType)){%>
<!-- List -->
<div id="listDiv" class="container-fluid" style="display: none;">
	<div class="m-2 expand-lg">
		<table id="list" class="cell-border hover" style="width:100%">
			<thead>
				<tr>
					<th>Name</th>
					<th>Description</th>
					<th></th>
				</tr>
			</thead>
			<tbody>
<%
List<CategoryData> dataList = dao.selectList();
for(int i = 0; i < dataList.size(); i++){
	CategoryData data = dataList.get(i);

	String name = data.name;
	int domainCnt = data.getDomainCount();
	if(domainCnt > 0){
		name = name + " - " + domainCnt;
	}
%>
				<tr>
					<td><%= name%></td>
					<td><%= data.description%></td>
					<td>
						<i class="fa fa-pencil-square pointer-cursor" title="Edit" onclick="javascript:goEdit(<%= data.id%>)"></i>
					</td>
				</tr>
<%}%>
			</tbody>
		</table>
	</div>
</div>
<!-- /List -->
<%}%>

<!-- goForm -->
<form name="goForm" method="get">
<input type="hidden" name="actionFlag" value="">
<input type="hidden" name="id" value="">
</form>
<!-- /goForm -->

<%@include file="include/footer.jsp"%>

<script>
$(document).ready(function(){
	$("#list").DataTable({
		"bFilter" : false,
		"paging" : false,
		"ordering" : false,
		"info" : true,
		"columnDefs": [{
			"targets": 2,
			"width": "50"
		}],
		"initComplete": function(settings, json){
			$("#listDiv").show();
		},
	});
});

//-----------------------------------------------
function goEdit(id){
	var form = document.goForm;
	form.action = "category,system_edit.jsp";
	form.id.value = id;
	form.submit();
}
</script>
