<%@include file="include/header.jsp"%>
<%!
//-----------------------------------------------
void update(AllowedIpDao dao){
	if(demoFlag){
		errList.add("Not allowed on demo site.");
		return;
	}

	AllowedIpData oldData = dao.selectOne();

	AllowedIpData data = new AllowedIpData();
	data.dnsAllowed = paramString("dnsAllowed");
	data.dnsBlocked = paramString("dnsBlocked");
	//data.loginAllowed = paramString("loginAllowed");
	data.guiAllowed = paramString("guiAllowed");
	data.bypassAll = paramString("bypassAll");

	if(oldData.dnsAllowed.length() < data.dnsAllowed.length()){
		errList.add("'Allowed IP for DNS' has been deprecated. Use 'DNS > Access Control' instead.");
		return;
	}

	if(oldData.dnsBlocked.length() < data.dnsBlocked.length()){
		errList.add("'Blocked IP for DNS' has been deprecated. Use 'DNS > Access Control' instead.");
		return;
	}

	if(oldData.bypassAll.length() < data.bypassAll.length()){
		errList.add("'Bypass All' has been deprecated. Use 'DNS > Access Control' instead.");
		return;
	}

	if(dao.update(data)){
		succList.add("Data updated.");
	}
}
%>
<%
//-----------------------------------------------
// Set permission for this page.
permission.addAdmin();

//Check permission.
if(!checkPermission()){
	return;
}

// Create data access object.
AllowedIpDao dao = new AllowedIpDao();

// Action.
String actionFlag = paramString("actionFlag");
if(actionFlag.equals("update")){
	update(dao);
}

// Global.
AllowedIpData data = dao.selectOne();

if(isEmpty(actionFlag)){
	warnList.add("This is only for GUI access control. Access control for DNS has been moved into 'DNS > Access Control'.");
}
%>
<!-- Action info -->
<%@include file="include/ab-notify.jsp"%>
<!-- /Action info -->

<!-- Breadcrumb -->
<div class="container-fluid primary" style="margin-top:-5px;">
	<ol class="breadcrumb" style="margin-left:10px; margin-right:10px;">
		<li class="breadcrumb-item">Config</li>
		<li class="breadcrumb-item text-info">Allowed IP</li>
	</ol>
</div>
<!-- /Breadcrumb -->

<!-- Main content -->
<div class="container-fluid">

	<div class="card bg-light m-2 expand-lg">
		<div class="card-body">
			<form action="<%= getPageName()%>" method="post">
				<input type="hidden" name="actionFlag" value="update">

				<div class="form-group col-lg-8 text-secondary">
					This is an IP based access control. You can add IP addresses in the following format.
					</p>

					<div class="tab">
						ex) 192.168.1 - IP addresses which start with '192.168.1'<br>
					</div>
					</p>

				* You can add multiple IP addresses separated by spaces or newlines.<br>
					<div class="tab">
						ex) 192.168.1 192.168.2<br>
						192.168.3
					</div>
					</p>

				* For exact matching add a tailing dot.<br>
					<div class="tab">
						ex) 192.168.0.100. 192.168.0.200.
					</div>
				</div>

				<div class="form-group col-lg-8">
					<label class="col-form-label">
						Allowed IP for DNS
						<i class="fa fa-question-circle south-east" title="Deprecated."></i>
					</label>
					<textarea class="form-control" id="dnsAllowed" name="dnsAllowed"><%= data.dnsAllowed%></textarea>
				</div>

				<div class="form-group col-lg-8">
					<label class="col-form-label">
						Blocked IP for DNS
						<i class="fa fa-question-circle south-east" title="Deprecated."></i>
					</label>
					<textarea class="form-control" id="dnsBlocked" name="dnsBlocked"><%= data.dnsBlocked%></textarea>
				</div>

				<div class="form-group col-lg-8">
					<label class="col-form-label">
						Allowed IP to GUI
						<i class="fa fa-question-circle south-east" title="'localhost' or '127.0.0.1' always allowed for accessing admin GUI."></i>
					</label>
					<textarea class="form-control" id="guiAllowed" name="guiAllowed"><%= data.guiAllowed%></textarea>
				</div>

				<div class="form-group col-lg-8">
					<label class="col-form-label">
						Bypass All
						<i class="fa fa-question-circle south-east" title="Deprecated."></i>
					</label>
					<textarea class="form-control" id="bypassAll" name="bypassAll"><%= data.bypassAll%></textarea>
				</div>

				<div class="form-group col-lg-8">
					<button type="submit" class="btn btn-primary">Submit</button>
				</div>

			</form>
		</div>
	</div>

</div>
<!-- /Main content -->

<%@include file="include/footer.jsp"%>
