<%@include file="include/header.jsp"%>
<%!
//-----------------------------------------------
void update(PolicyNxProxyDao dao){
	PolicyNxProxyData data = new PolicyNxProxyData();
	data.enableFilter = paramBoolean("enableFilter");
	data.localDns = paramString("localDns");
	data.localDomain = paramString("localDomain");

	if(dao.update(data)){
		succList.add("Data updated.");
	}
}
%>
<%
//-----------------------------------------------
// Set permission for this page.
permission.addAdmin();

//Check permission.
if(!checkPermission()){
	return;
}

// Create data access object.
PolicyNxProxyDao dao = new PolicyNxProxyDao();

// Action.
String actionFlag = paramString("actionFlag");
if(actionFlag.equals("update")){
	update(dao);
}

// Global.
PolicyNxProxyData data = dao.selectOne();
%>
<!-- Action info -->
<%@include file="include/ab-notify.jsp"%>
<!-- /Action info -->

<!-- Breadcrumb -->
<div class="container-fluid primary" style="margin-top:-5px;">
	<ol class="breadcrumb" style="margin-left:10px; margin-right:10px;">
		<li class="breadcrumb-item">POLICY</li>
		<li class="breadcrumb-item text-info">NXPROXY</li>
	</ol>
</div>
<!-- /Breadcrumb -->

<!-- Main content -->
<div class="container-fluid">

	<div class="card bg-light m-2 expand-lg">
		<div class="card-body">
			<form action="<%= getPageName()%>" method="post">
				<input type="hidden" name="actionFlag" value="update">

				<div class="form-group col-lg-8 text-secondary">
					 NxProxy is a DNS (DoH) level remote filtering agent.
				</div>
				<div class="form-group col-lg-8">
					<div class="custom-control custom-checkbox">
						<input type="checkbox" class="custom-control-input" id="enableFilter"
							name="enableFilter" <%if(data.enableFilter){out.print("checked");}%>>
						<label for="enableFilter" class="custom-control-label">Enable Filter</label>
					</div>
				</div>
				<div class="form-group col-lg-8">
					<label class="col-form-label">
						Local Domain
						<i class="fa fa-question-circle south-east" title="This is for bypassing local domains. You can add multiple domains separated by spaces.
							<br>&nbsp;&nbsp;ex) www.nxfilter.local *.jahastech.local"></i>
					</label>
					<textarea class="form-control" id="localDomain" name="localDomain"><%= data.localDomain%></textarea>
				</div>
				<div class="form-group col-lg-8">
					<label class="col-form-label">
						Local DNS Server
						<i class="fa fa-question-circle south-east" title="This is optional. NxProxy will try to find the DNS server in its network by itself.
							<br>This is for when you want to specify your own DNS server for sure."></i>
					</label>
					<input type="text" class="form-control" id="localDns" name="localDns"
						value="<%= data.localDns%>">
					<small id="input-help" class="form-text text-muted">
						Multiple IP addresses should be separated by commas.
					</small>
				</div>
				<div class="form-group col-lg-8">
					<button type="submit" class="btn btn-primary">Submit</button>
				</div>

			</form>
		</div>
	</div>

</div>
<!-- /Main content -->

<%@include file="include/footer.jsp"%>
