<%@include file="include/header.jsp"%>
<%!
//-----------------------------------------------
void quotaReset(UserTestDao dao){
	if(dao.quotaReset(paramString("name"))){
		succList.add("Data updated.");
	}
}

//-----------------------------------------------
void bwdtReset(UserTestDao dao){
	if(dao.bwdtReset(paramString("name"))){
		succList.add("Data updated.");
	}
}
%>
<%
//-----------------------------------------------
// Set permission for this page.
permission.addAdmin();

//Check permission.
if(!checkPermission()){
	return;
}

// Create data access object.
UserTestDao dao = new UserTestDao();

// Action.
String actionFlag = paramString("actionFlag");
if(actionFlag.equals("quotaReset")){
	quotaReset(dao);
}
if(actionFlag.equals("bwdtReset")){
	bwdtReset(dao);
}

// Global.
UserTestData data = dao.test(paramString("name"));
%>
<!-- Action info -->
<%@include file="include/ab-notify.jsp"%>
<!-- /Action info -->

<!-- Breadcrumb -->
<div class="container-fluid primary" style="margin-top:-5px;">
	<ol class="breadcrumb" style="margin-left:10px; margin-right:10px;">
		<li class="breadcrumb-item">USER</li>
		<li class="breadcrumb-item text-info">TEST</li>
	</ol>
</div>
<!-- /Breadcrumb -->

<!-- Main content -->
<div class="container-fluid">

	<div class="card bg-light m-2 expand-lg">
		<div class="card-body">
			<form action="<%= getPageName()%>" method="post">
				<input type="hidden" name="actionFlag" value="update">
				<fieldset>
					<div class="form-row col-lg-8">
						<label class="col-form-label col-lg-2 col-sm-2">Name</label>
						<label class="col-form-label"><%= data.name%></label>
					</div>
					<div class="form-row col-lg-8">
						<label class="col-form-label col-lg-2 col-sm-2">Group</label>
						<label class="col-form-label"><%= data.groupName%></label>
					</div>
					<div class="form-row col-lg-8">
						<label class="col-form-label col-lg-2 col-sm-2">User Policy</label>
						<label class="col-form-label"><%= data.policyName%></label>
					</div>
					<div class="form-row col-lg-8">
						<label class="col-form-label col-lg-2 col-sm-2">Applied Policy</label>
						<label class="col-form-label"><%= data.appliedPolicyName%></label>
					</div>
					<div class="form-row col-lg-8">
						<label class="col-form-label col-lg-2 col-sm-2">Free-time</label>
						<label class="col-form-label"><%= data.isFreeTime ? "Yes" : "No"%></label>
					</div>
					<div class="form-row col-lg-8">
						<label class="col-form-label col-lg-2 col-sm-2">Quota</label>
						<label class="col-form-label"><%= data.quotaConsumed%> / <%= data.quotaLimit%> minutes</label>
					</div>
					<div class="form-row col-lg-8">
						<label class="col-form-label col-lg-2 col-sm-2">Bandwidth</label>
						<label class="col-form-label"><%= data.bandwidthConsumed%> / <%= data.bandwidthLimit%> MB</label>
					</div>
					<div class="form-group col-lg-8" style="margin-top: 10px;">
						<button type="button" class="btn btn-info" onclick="javascript:actionQuotaResetUser(this.form);">RESET QUOTA</button>
						<button type="button" class="btn btn-warning" onclick="javascript:actionBandwidthResetUser(this.form);">RESET BANDWIDTH</button>
					</div>
				</fieldset>
			</form>
		</div>
	</div>

</div>
<!-- /Main content -->

<%@include file="include/footer.jsp"%>

<script>
//-----------------------------------------------
function actionQuotaResetUser(form){
	form.actionFlag.value = "quotaReset";
	form.submit();
}

//-----------------------------------------------
function actionBandwidthResetUser(form){
	form.actionFlag.value = "bwdtReset";
	form.submit();
}
</script>
