<%@include file="include/header.jsp"%>
<%!
//-----------------------------------------------
void update(WhitelistDomainDao dao){
	WhitelistData data = new WhitelistData();
	data.id = paramInt("id");
	data.description = paramString("description");

	data.bypassAuth = paramBoolean("bypassAuth");
	data.bypassFilter = paramBoolean("bypassFilter");
	data.bypassLog = paramBoolean("bypassLog");
	data.adminBlock = paramBoolean("adminBlock");
	data.dropPacket = paramBoolean("dropPacket");
	data.appliedPolicyArr = paramArray("appliedPolicyArr");

	if((data.bypassAuth || data.dropPacket)
		&& (data.appliedPolicyArr != null && data.appliedPolicyArr.length > 0)){

		errList.add("'Bypass Authetication' and 'Drop Packet' should be applied on global level.");
		return;
	}

	if(dao.update(data)){
		succList.add("Data updated.");
	}
}
%>
<%
//-----------------------------------------------
// Set permission for this page.
permission.addAdmin();

//Check permission.
if(!checkPermission()){
	return;
}

// Create data access object.
WhitelistDomainDao dao = new WhitelistDomainDao();

// Action.
String actionFlag = paramString("actionFlag");
if(actionFlag.equals("update")){
	update(dao);
}

// Global.
WhitelistData data = dao.selectOne(paramInt("id"));

// Get policy list.
PolicyDao polDao = new PolicyDao();
Map<Integer, String> policyIdNameMap = dao.getPolicyIdNameMap();
%>
<!-- Action info -->
<%@include file="include/ab-notify.jsp"%>
<!-- /Action info -->

<!-- Breadcrumb -->
<div class="container-fluid primary" style="margin-top:-5px;">
	<ol class="breadcrumb" style="margin-left:10px; margin-right:10px;">
		<li class="breadcrumb-item">WHITELIST</li>
		<li class="breadcrumb-item">DOMAIN</li>
		<li class="breadcrumb-item text-info">EDIT</li>
	</ol>
</div>
<!-- /Breadcrumb -->

<!-- Main content -->
<div class="container-fluid">

	<div class="card bg-light m-2 expand-lg">
		<div class="card-body">
			<form action="<%= getPageName()%>" method="post">
				<input type="hidden" name="actionFlag" value="update">
				<input type="hidden" name="id" value="<%= data.id%>">

				<div class="form-group col-lg-8">
					<label class="col-form-label">Domain</label>
					<input type="text" class="form-control" id="domain" name="domain" value="<%= data.domain%>" disabled>
				</div>
				<div class="form-group col-lg-8">
					<label class="col-form-label">Description</label>
					<input type="text" class="form-control" id="description" name="description" value="<%= data.description%>">
				</div>
				<div class="form-group col-lg-8">
					<div class="custom-control custom-checkbox">
						<input type="checkbox" class="custom-control-input" id="bypassAuth" name="bypassAuth"
							<%if(data.bypassAuth){out.print("checked");}%>>
						<label for="bypassAuth" class="custom-control-label">Bypass Authentication</label>
					</div>
				</div>
				<div class="form-group col-lg-8">
					<div class="custom-control custom-checkbox">
						<input type="checkbox" class="custom-control-input" id="bypassFilter" name="bypassFilter"
							<%if(data.bypassFilter){out.print("checked");}%>>
						<label for="bypassFilter" class="custom-control-label">Bypass Filtering</label>
					</div>
				</div>
				<div class="form-group col-lg-8">
					<div class="custom-control custom-checkbox">
						<input type="checkbox" class="custom-control-input" id="bypassLog" name="bypassLog"
							<%if(data.bypassLog){out.print("checked");}%>>
						<label for="bypassLog" class="custom-control-label">Bypass Logging</label>
					</div>
				</div>
				<div class="form-group col-lg-8">
					<div class="custom-control custom-checkbox">
						<input type="checkbox" class="custom-control-input" id="adminBlock" name="adminBlock"
							<%if(data.adminBlock){out.print("checked");}%>>
						<label for="adminBlock" class="custom-control-label">Admin Block</label>
					</div>
				</div>
				<div class="form-group col-lg-8">
					<div class="custom-control custom-checkbox">
						<input type="checkbox" class="custom-control-input" id="dropPacket" name="dropPacket"
							<%if(data.dropPacket){out.print("checked");}%>>
						<label for="dropPacket" class="custom-control-label">Drop Packet</label>
					</div>
				</div>


				<div class="form-group col-lg-8">
					<label class="col-form-label">Applied Policy</label>
					<select class="form-control" id="appliedPolicyArr" name="appliedPolicyArr" multiple>
<%
for(Map.Entry<Integer, String> e: policyIdNameMap.entrySet()){
	int policyId = e.getKey();
	String policyName = e.getValue();

	String chkLine = "";
	if(data.isAppliedPolicy(policyId)){
		chkLine = " selected";	
	}
	printf("<option value='%s'%s>%s</option>\n", policyId, chkLine, policyName);
}
%>
					</select>
				</div>

				<div class="form-group col-lg-8">
					<button type="submit" class="btn btn-primary">Submit</button>
				</div>

			</form>
		</div>
	</div>

</div>
<!-- /Main content -->

<%@include file="include/footer.jsp"%>
